program clp2ip;  { convert clp-data to ip-data }
                 { clp2mlp.pas + mlp2ip.pas }
const
   imax = 500; jmax = 255;  {1999.6.23}
{   imax = 60; jmax = 60;}
type
   pa_array = ^a_array;
   a_array = array[0..jmax] of real;
   aptr = array[0..imax] of pa_array;

var
   iee, igg : array[1..imax] of integer;
   seiyaku : array[1..imax] of string;
   ivv : array[1..jmax] of integer;
   process : array[1..jmax] of string;
   a : aptr;
   str1 : string[1];
   str2 : string[2];
   title : string;
   ndata, i, j, iv, idmy, m, n, ie, ig : integer;
   tfile : text;
   ch : char;
   str : string;
   moji, dend : boolean;

procedure write_data;
begin
   writeln(tfile, str); str := '';
   moji := false; dend := false;
   if ndata = 4 then val(str,ie,idmy);
   if ndata = 5 then val(str,ig,idmy);
end;

(*-----------------------------------------------------------------------------
procedure clp2clp; {rewrite in the form that only one data is in one line }
begin
   assign(tfile,'tmp.$$$'); rewrite(tfile);
   str := ''; moji := false; dend := false; ndata := 1;
   ie := 0; ig := 0;
   while not eof do begin
      read(ch);
      if eoln then begin
         write_data; ndata := ndata + 1; readln;
      end else if ch = ',' then begin
         write_data; ndata := ndata + 1
      end else if ch = ' ' then begin
         if moji and ( (1 < ndata) and (ndata < 8 + ie + ig) ) then dend := true;
{         if moji then dend := true;}
      end else begin 
         if dend then begin
            write_data;
            ndata := ndata + 1
         end;
         if not dend then begin
            str := str + ch; moji := true;
         end;
      end;
   end;
   close(tfile);
end;
-----------------------------------------------------------------------------*)

procedure clp2ipd;
begin
   readln(title);
   readln(m, n, ie, ig);
   if ie > 0 then begin
      for i := 1 to ie do read(iee[i]); readln;
   end;
   if ig > 0 then begin
      for i := 1 to ig do read(igg[i]); readln;
   end;
   for i := 1 to n do readln(process[i]);
   for i := 1 to m do readln(seiyaku[i]);
   for i := 0 to m do begin
      for j := 0 to n do begin
         readln(a[i]^[j]);
{         if i = 0 then a[i][j] := -a[i]^[j];}
      end;
   end;

   iv := 0;
   for i := 1 to n do begin
      str1 := process[i,1];
      str2 := process[i,1] + process[i,2];
      if (str1 = '*') or (str2 = '') then begin
         iv := iv + 1;
         ivv[iv] := i;
      end;
   end;

   
   writeln(title:1);
   writeln(m:5, n:5, ie:5, ig:5, iv:5);
   
   if ie <> 0 then begin
      for i := 1 to ie do write(iee[i]:5);
      writeln;
   end;
   
   if ig <> 0 then begin
      for i := 1 to ig do write(igg[i]:5);
      writeln;
   end;
   
   if iv <> 0 then begin
      for i := 1 to iv do write(ivv[i]:5);
      writeln;
   end;
   
   for j := 1 to n do  writeln(process[j]:1);
   
   for i := 1 to m do  writeln(seiyaku[i]:1);
   
   for i := 0 to m do begin
      for j := 0 to n do
         if (a[i]^[j] < -1.0e-7) or (1.0e-7 < a[i]^[j]) then
            writeln(i:5, j:5, a[i]^[j]:15:5);
   end;
   
   idmy := 30000;
   writeln(idmy:5);
end;

begin
   for i:= 0 to imax do new(a[i]);
{   clp2clp;}
   clp2ipd;
   for i:= 0 to imax do dispose(a[i]);
end.
